public with sharing class SalesIQDataTableCtrl_V2 
{
    static String namespacePrefix = SalesIQGlobalConstants.NAME_SPACE ;
    
    @AuraEnabled
    public static String getOrgNamespace() 
    {
        return SalesIQGlobalConstants.NAME_SPACE;        
    }

    @AuraEnabled
    public static boolean isScenarioLock(String scenarioId){
        return [SELECT Is_Locked__c FROM Scenario__c where id =: scenarioId ].Is_Locked__c;
    }
    
    @AuraEnabled
    public static String initialiseDataTable(String moduleName, string selectedTeamInstance, String selectedPositionId, String subInterface, String recordId,String countryId)
    {   
        try {
            // User sitting on which position is required by Call Plan module

            String teamInstanceDisplayName = '', scenarioStage = '' , scenarioID = '', workspaceID='', scenarioSource='';
            String startDate, endDate;
            system.debug('---> ' + countryId);
            
            //REMOVED DEFAULT COUNTRY CHECK. DEFAULT COUNTRY VALIDATED AND UPDATED VIA IN SALESIQLISTVIEW OR SALESIQDATATABLE
            /*if(countryId == '' || countryId == null){
                countryId = SalesIQUtility.getDefaultCountryID(UserInfo.getUserId());
            }*/

            if(moduleName == SalesIQGlobalConstants.MODULE_TYPE_CR_CALL_PLAN) {
                // recordId is available in case of CR Call Plan incline page, which is of type Change Request
                list<Change_Request__c> queryChangeRequest = SalesIQUtility.getChangeRequestByIds(new Set<Id>{(Id)recordId});
                selectedTeamInstance = queryChangeRequest[0].Team_Instance_ID__c;
                selectedPositionId = queryChangeRequest[0].Destination_Position__c;
            }

            if(moduleName == SalesIQGlobalConstants.CALL_PLAN_MODULE || moduleName == SalesIQGlobalConstants.MODULE_TYPE_CR_CALL_PLAN) {
                if(selectedTeamInstance == '' || selectedTeamInstance == null)
                {
                    list<Team_Instance__c> callPlanTeamInstances = SalesIQUtility.getUserAccessTeamInstance(null, moduleName,countryId);
                    if(callPlanTeamInstances.size() < 1)
                    {
                        AuraHandledException ex = new AuraHandledException(System.Label.No_UAP_Assigned);
                        ex.setMessage(System.Label.No_UAP_Assigned);
                        throw ex;
                    }

                    selectedTeamInstance = callPlanTeamInstances[0].Id;
                    startDate = callPlanTeamInstances[0].IC_EffstartDate__c.format() ;
                    endDate = callPlanTeamInstances[0].IC_EffEndDate__c.format() ;
                    selectedPositionId = callPlanTeamInstances[0].User_Access_Permissions__r[0].Position__c;

                    //teamInstanceDisplayName = callPlanTeamInstances[0].Scenarios__r[0].Name + ' ' + callPlanTeamInstances[0].Name;
                    // SPD-4938, SPD-4442
                    teamInstanceDisplayName = callPlanTeamInstances[0].Scenarios__r[0].Scenario_Name__c;
                    scenarioStage = callPlanTeamInstances[0].Scenarios__r[0].Scenario_Stage__c ;
                    scenarioID = callPlanTeamInstances[0].Scenarios__r[0].ID;
                    workspaceID = callPlanTeamInstances[0].Scenarios__r[0].Workspace__r.Id;
                    scenarioSource = callPlanTeamInstances[0].Scenarios__r[0].Scenario_Source__c;

                } else {
                    list<Team_Instance__c> callPlanTeamInstances = SalesIQUtility.getUserAccessTeamInstance(selectedTeamInstance, moduleName,countryId);
                    if(selectedPositionId == '' || selectedPositionId == null)
                        selectedPositionId = callPlanTeamInstances[0].User_Access_Permissions__r[0].Position__c;

                    //teamInstanceDisplayName = callPlanTeamInstances[0].Scenarios__r[0].Name + ' ' + callPlanTeamInstances[0].Name;
                    // SPD-4938, SPD-4442
                    teamInstanceDisplayName = callPlanTeamInstances[0].Scenarios__r[0].Scenario_Name__c;
                    startDate = callPlanTeamInstances[0].IC_EffstartDate__c.format() ;
                    endDate = callPlanTeamInstances[0].IC_EffEndDate__c.format() ;
                    scenarioStage = callPlanTeamInstances[0].Scenarios__r[0].Scenario_Stage__c ;
                    scenarioID = callPlanTeamInstances[0].Scenarios__r[0].ID;
                    workspaceID = callPlanTeamInstances[0].Scenarios__r[0].Workspace__r.Id;
                    scenarioSource = callPlanTeamInstances[0].Scenarios__r[0].Scenario_Source__c;
                }
            } 
            else if(moduleName == SalesIQGlobalConstants.INTERFACE_NAME_POSITION_EMPLOYEE ){

            }
            // For modules other than call plan
            else {
                if(selectedTeamInstance == '' || selectedTeamInstance == null){
                    list<User_Access_Permission__c> listUserAccessPermission = SalesIQUtility.getLoggedInUserAccessRecords(true, null, moduleName);
                    if(listUserAccessPermission.size() < 1)
                    {
                        AuraHandledException ex = new AuraHandledException(System.Label.No_UAP_Assigned);
                        ex.setMessage(System.Label.No_UAP_Assigned);
                        throw ex;
                    }

                    selectedTeamInstance = listUserAccessPermission[0].Team_Instance__c;
                    startDate = listUserAccessPermission[0].Team_Instance__r.IC_EffstartDate__c.format() ;
                    endDate = listUserAccessPermission[0].Team_Instance__r.IC_EffEndDate__c.format() ;
                    selectedPositionId = listUserAccessPermission[0].Position__c;

                    /*if(listUserAccessPermission[0].Team_Instance__r.Scenario__c == null) {
                        teamInstanceDisplayName = listUserAccessPermission[0].Team_Instance__r.Name;
                    }
                    else {
                        teamInstanceDisplayName = listUserAccessPermission[0].Team_Instance__r.Scenario__r.Name + ' ' + listUserAccessPermission[0].Team_Instance__r.Name;
                    }*/
                    // SPD-4938, SPD-4442
                    teamInstanceDisplayName = listUserAccessPermission[0].Team_Instance__r.Scenario__r.Scenario_Name__c;

                }
                else {
                    list<User_Access_Permission__c> listUserAccessPermission = SalesIQUtility.getLoggedInUserAccessRecords(true, selectedTeamInstance, moduleName);
                    
                    if(selectedPositionId == null)
                        selectedPositionId = listUserAccessPermission[0].Position__c;

                    /*if(listUserAccessPermission[0].Team_Instance__r.Scenario__c == null) {
                        teamInstanceDisplayName = listUserAccessPermission[0].Team_Instance__r.Name;
                    }
                    else {
                        teamInstanceDisplayName = listUserAccessPermission[0].Team_Instance__r.Scenario__r.Name + ' ' + listUserAccessPermission[0].Team_Instance__r.Name;
                    }*/
                    // SPD-4938, SPD-4442
                    teamInstanceDisplayName = listUserAccessPermission[0].Team_Instance__r.Scenario__r.Scenario_Name__c;
                }
            }

            List<Team_Instance_Object_Attribute__c> fetchAllRequiredColumns = new List<Team_Instance_Object_Attribute__c>();
            if(moduleName == SalesIQGlobalConstants.INTERFACE_NAME_POSITION_EMPLOYEE ){
                fetchAllRequiredColumns = SalesIQUtility.getTeamInstanceAttrFromInterfaceName(SalesIQGlobalConstants.INTERFACE_NAME_POSITION_EMPLOYEE);
            }
            else
                fetchAllRequiredColumns = SalesIQUtility.getTeamInstanceAttr(new List<String>{moduleName}, new List<String>{selectedTeamInstance}, false, true);
            system.debug('--fetchAllRequiredColumns ' + fetchAllRequiredColumns);

            List<ColumnHeaderWrapper> rowHeaderWrapperList = new List<ColumnHeaderWrapper>();
            List<String> columnsData = new List<String>();
            String allFields = ''; 
            if(subInterface != '')
            {
                //columnsData.add('{"name" : "" , "defaultContent": "" , "title": "<input type=\'checkbox\' class=\'select-checkbox selectAllcheckbox\' id=\'sel-all\'></input>","orderable":false}');
                columnsData.add('{"name" : "" , "defaultContent": "" , "title": "Select","orderable":false}');
                rowHeaderWrapperList.add(new ColumnHeaderWrapper('Checkbox'));
            }
            else if(moduleName == SalesIQGlobalConstants.CALL_PLAN_MODULE)
            {
                columnsData.add('{"name" : "Drop" , "defaultContent": "" , "title": "Drop","orderable":true, "width" : "7%" }');
                rowHeaderWrapperList.add(new ColumnHeaderWrapper('Checkbox'));
            }
            
            INTEGER f = 0;
            for(Team_Instance_Object_Attribute__c attribute : fetchAllRequiredColumns) 
            {
                if(attribute.Attribute_API_Name__c == 'Id')
                {
                    f = 1;
                }

                if(subInterface != '' && attribute.IsEnabled_Account_Universe__c == true){
                    attribute.isEnabled__c = true;
                    attribute.Display_Column_Order__c = attribute.Display_Order_Account_Universe__c;
                    attribute.isEditable__c = attribute.IsEditable_Account_Universe__c;

                    rowHeaderWrapperList.add(new ColumnHeaderWrapper(attribute, attribute.Object_Attribute_Details__r));
                    columnsData.add('{ "data": "' + attribute.Attribute_API_Name__c + '", "name" : "' + attribute.Attribute_API_Name__c + '" , "defaultContent": "" , "width" : "' + attribute.Width__c + '%' + '" ,"title": "'+attribute.Attribute_Display_Name__c+'"}');
                    allFields = allFields + attribute.Attribute_API_Name__c + ',';
                }
                
                if(attribute.isEnabled__c && subInterface == ''){
                    rowHeaderWrapperList.add(new ColumnHeaderWrapper(attribute, attribute.Object_Attribute_Details__r));
                    columnsData.add('{ "data": "' + attribute.Attribute_API_Name__c + '", "name" : "' + attribute.Attribute_API_Name__c + '" , "defaultContent": "" , "width" : "' + attribute.Width__c + '%' +  '" , "title": "'+attribute.Attribute_Display_Name__c+'"}');
                    allFields = allFields + attribute.Attribute_API_Name__c + ',';
                }
            }
            if(f != 1)
            {
                columnsData.add('{ "data" : "Id", "name" : "Id" , "defaultContent": "" , "title": "Id","orderable":false,"visible" : false}');
                rowHeaderWrapperList.add(new ColumnHeaderWrapper('Id'));
                allFields = allFields + 'Id,';
            }

            allFields = allFields.removeEnd(',');

            if(moduleName == SalesIQGlobalConstants.CALL_PLAN_MODULE || moduleName == SalesIQGlobalConstants.MODULE_TYPE_CR_CALL_PLAN) {
                // in case of call Plan  module, get the terrirtory position as selected position from the position where user is sitting. 
                //List<Position__c> territoryPositions = SalesIQUtility.getPositionWithSortFieldDynamic('1', selectedPositionId, true, 1);
                List<Position__c> territoryPositions = SalesIQUtility.getPositionWithSortFieldDynamic('1',selectedTeamInstance, selectedPositionId,true, 1);
                System.debug('territoryPositions -'+territoryPositions);
                selectedPositionId = territoryPositions[0].Id;
            }

            
            List<String> orderDefaultList = new List<String>();
            
            //The code sets the default sort of the table on load
            /*Integer index = 0;
            for(ColumnHeaderWrapper headerWrapObj : rowHeaderWrapperList){
                if(headerWrapObj.isEditable == false){
                    if(headerWrapObj.fieldDataType == 'Number'){
                        orderDefaultList.add('[ ' + index + ' , "desc" ]');
                    }
                    else{
                        orderDefaultList.add('[ ' + index + ' , "asc" ]');
                    }
                }
                index++;
            }*/

            ColumnsHeaderResponse response = new ColumnsHeaderResponse(JSON.serialize(rowHeaderWrapperList), '['+String.join(columnsData, ',')+']', selectedTeamInstance, selectedPositionId, teamInstanceDisplayName, scenarioStage, allFields, '['+String.join(orderDefaultList, ',')+']');
            response.selectedTeamInstanceStartDate = startDate;
            response.selectedTeamInstanceEndDate = endDate;
            response.scenarioID = scenarioID;
            response.workspaceID = workspaceID;
            response.scenarioSource = scenarioSource;

            if(subInterface != '')
                moduleName = SalesIqGlobalConstants.ADD_TARGET_MODULE;

            List<CR_Team_Instance_Config__c> listCRteamInsConfig = [Select Team_Instance__c,RowHeight__c, Bulk_Edit_Allowed__c, Fixed_Column_From_Left__c, Fixed_Column_From_Right__c, Page_Size__c, Pagination_on__c, IsWrapText__c, MaximumRecordsSaved__c from CR_Team_Instance_Config__c where (Team_Instance__c =: selectedTeamInstance or Team_Instance__c = null) and Configuration_Name__c =: moduleName and Configuration_Type__c =: SalesIQGlobalConstants.DATA_TABLE_CONFIG];

            Map<String, CR_Team_Instance_Config__c> mapCRTeamInsIdANDobj = new Map<String, CR_Team_Instance_Config__c>();
            for(CR_Team_Instance_Config__c crTeamInsObj : listCRteamInsConfig){
                if(crTeamInsObj.Team_Instance__c == selectedTeamInstance){
                    mapCRTeamInsIdANDobj.put(crTeamInsObj.Team_Instance__c, crTeamInsObj);
                    break;
                }
                else
                    mapCRTeamInsIdANDobj.put('global', crTeamInsObj);
            }

            CR_Team_Instance_Config__c crTeamInsObj;
            if(mapCRTeamInsIdANDobj.containsKey(selectedTeamInstance))
                crTeamInsObj= mapCRTeamInsIdANDobj.get(selectedTeamInstance);
            else if(mapCRTeamInsIdANDobj.containsKey('global'))
                crTeamInsObj= mapCRTeamInsIdANDobj.get('global');

            if(crTeamInsObj != null){
                response.bulkEditAllowed = crTeamInsObj.Bulk_Edit_Allowed__c;

                if(crTeamInsObj.IsWrapText__c == null)
                    response.isWrapText = false;
                else
                    response.isWrapText = crTeamInsObj.IsWrapText__c;

                if(crTeamInsObj.RowHeight__c == null)
                    response.rowHeight = 25;
                else
                    response.rowHeight = crTeamInsObj.RowHeight__c;
                    
                if(crTeamInsObj.Fixed_Column_From_Left__c == null)
                    response.fixedColumnFromLeft = 0;
                else
                    response.fixedColumnFromLeft = crTeamInsObj.Fixed_Column_From_Left__c;

                if(crTeamInsObj.Fixed_Column_From_Right__c == null)
                    response.fixedColumnFromRight = 0;
                else
                    response.fixedColumnFromRight = crTeamInsObj.Fixed_Column_From_Right__c;

                response.paginationOn = crTeamInsObj.Pagination_on__c;
                
                if(crTeamInsObj.Page_Size__c == null)
                    response.paginationSize = 10;
                else
                    response.paginationSize = crTeamInsObj.Page_Size__c;

                if(crTeamInsObj.MaximumRecordsSaved__c == null)
                    response.maximumRecordsSaved = 1000;
                else
                    response.maximumRecordsSaved = crTeamInsObj.MaximumRecordsSaved__c;

            }
            else{
                response.bulkEditAllowed = false;
                response.fixedColumnFromLeft = 0;
                response.fixedColumnFromRight = 0;
                response.paginationSize = 10;
                response.paginationOn = true;
                response.maximumRecordsSaved = 1000;
                response.rowHeight = 25;
            }

            return (JSON.serialize(response)) ;

        } catch(Exception e) {
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
            throw ex;
        }
    }

    @AuraEnabled
    public static Response runQuery(String moduleName, String recordId, String stringifiedRequest, String selectedPositionId, String selectedTeamInstanceId, String columnHeadersAPIname, String whereClausePACP,String subInterface, String ObjectDetailWrapperList)
    {   
        try {
            system.debug('--RunQuery Called');
            system.debug('Position' + selectedPositionId);
            system.debug('team instance' + selectedTeamInstanceId);
            system.debug('subInterface ' + subInterface);
            system.debug('moduleName ' + moduleName);

            Map<String, Object> request  = (Map<String,Object>)JSON.deserializeUntyped(stringifiedRequest);
            Integer start  = Integer.valueOf((Decimal)request.get('start'));
            Integer length = Integer.valueOf((Decimal)request.get('length'));
            Integer draw   = Integer.valueOf((Decimal)request.get('draw'));
            Map<String,Object> searchedVal = (Map<String,Object>)(request.get('search'));
            List<Object> allColumns = (List<Object>)(request.get('columns'));

            Response r1;
            Boolean isCallPlanSettingsEnabled = false;

            if(moduleName == SalesIQGlobalConstants.CALL_PLAN_MODULE && subInterface == ''){
                // get only Targeted records (isTarget_Updated__c = true)
                List<Position_Account_Call_Plan__c> pacpRecs = SalesIQUtility.getPositionAccountCallPlan(columnHeadersAPIname, selectedTeamInstanceId, selectedPositionId, length, start,whereClausePACP);
                
                system.debug('--pacpRecs ' + pacpRecs);

                Boolean crRaised = false;
                Boolean isReadOnly = false;

                if(ReadOnlyApplication__c.getInstance(UserInfo.getProfileId()) != null && ReadOnlyApplication__c.getInstance(UserInfo.getProfileId()).CallPlan__c)
                    isReadOnly = true;

                if(ReadOnlyApplication__c.getInstance(UserInfo.getProfileId()) != null && ReadOnlyApplication__c.getInstance(UserInfo.getProfileId()).Enable_Call_Plan_Settings__c)
                    isCallPlanSettingsEnabled = true;

                if(SalesIQUtility.isChangeRequestPending( (Id) selectedPositionId, new List<String>{SalesIQGlobalConstants.REQUEST_TYPE_CALL_PLAN}).size() > 0)
                    crRaised = true;
                
                r1 = new Response(draw, pacpRecs.size(), pacpRecs, crRaised, isReadOnly, isCallPlanSettingsEnabled);
            }
            else if(moduleName == SalesIQGlobalConstants.MODULE_TYPE_CR_CALL_PLAN){
                String soql = 'SELECT (SELECT ' + columnHeadersAPIname + ' FROM CR_Call_Plans1__r ) FROM Change_Request__c WHERE Id=:recordId';
                Change_Request__c listCR = Database.query(soql);

                r1 = new Response(draw, listCR.CR_Call_Plans1__r.size(), listCR.CR_Call_Plans1__r, true, true, isCallPlanSettingsEnabled);
            }
            else if(moduleName == SalesIQGlobalConstants.CALL_PLAN_MODULE && subInterface != ''){
                system.debug('moduleName ' + moduleName + ' ' + columnHeadersAPIname);
                if(subInterface == SalesIQGlobalConstants.ELIGIBLE_TARGETS)
                {
                    String dropped = SalesIQGlobalConstants.TARGET_DROPPED;
                    String approvedStatus = SalesIQGlobalConstants.REQUEST_STATUS_APPROVED;
                    List<Position_Account_Call_Plan__c> pacpRecs = Database.query('SELECT ' + columnHeadersAPIname + ' FROM Position_Account_Call_Plan__c WHERE Position__c =: selectedPositionId AND Team_Instance__c =: selectedTeamInstanceId AND ((isTarget_Updated__c = false AND Change_Action_Type__c = null) OR (Change_Action_Type__c =: dropped AND (Change_Status__c =: approvedStatus OR Change_Status__c = null OR Change_Status__c = \'No Change\') AND isTarget_Updated__c = false))');
                    r1 = new Response(draw, pacpRecs.size(), pacpRecs, false, false, isCallPlanSettingsEnabled);
                }
                else if(subInterface == SalesIQGlobalConstants.ELIGIBLE_ACROSS_TEAM_TARGETS){
                    List<Position_Account_Call_Plan__c> selectedPosPACP = [Select Account__c From Position_Account_Call_Plan__c Where Position__c =:selectedPositionId];
                    Set<Id> setAccountIds = new Set<Id>();
                    for(Position_Account_Call_Plan__c pacpObj : selectedPosPACP)
                        setAccountIds.add(pacpObj.Account__c);

                    List<Position_Account_Call_Plan__c> pacpRecs = Database.query('SELECT ' + columnHeadersAPIname + ' FROM Position_Account_Call_Plan__c WHERE Account__c Not in: setAccountIds AND Position__c !=: selectedPositionId AND  Team_Instance__c =: selectedTeamInstanceId AND ((isTarget_Updated__c = false AND Change_Action_Type__c = null) OR (Change_Action_Type__c =: dropped AND (Change_Status__c =: approvedStatus OR Change_Status__c = null OR Change_Status__c = \'No Change\') AND isTarget_Updated__c = false))');

                    r1 = new Response(draw, pacpRecs.size(), pacpRecs, false, false, isCallPlanSettingsEnabled);   
                }
                else if(subInterface == SalesIQGlobalConstants.WHOLE_UNIVERSE_TARGETS)
                {
                    List<Account> listAccount = Database.query('SELECT '+ columnHeadersAPIname + ', (SELECT Id FROM Position_Account_CallPlans__r WHERE Position__c =: selectedPositionId AND Team_Instance__c =: selectedTeamInstanceId AND isTarget_Updated__c = true)  FROM Account');
                    
                    List<Account> filteredAccount = new List<Account>();
                    
                    for(Account objAcc : listAccount){
                        Account accObj = new Account();
                        if(objAcc.Position_Account_CallPlans__r.size() == 0){
                            for(String fieldAPI : columnHeadersAPIname.split(','))
                                accObj.put(fieldAPI, objAcc.get(fieldAPI));
                            filteredAccount.add(accObj);
                        }
                    }

                    r1 = new Response(draw, filteredAccount.size(), filteredAccount, false, false, isCallPlanSettingsEnabled);   
                }

            }
            else if(moduleName == SalesIQGlobalConstants.INTERFACE_NAME_POSITION_EMPLOYEE ){
                List<ObjectDetailWrapper> recordDetails = (List<ObjectDetailWrapper>)JSON.deserialize(ObjectDetailWrapperList, List<ObjectDetailWrapper>.class);
                List<Position_Employee__c> posEmpList = new List<Position_Employee__c>();
                
                for(ObjectDetailWrapper positionEmployeeWrapper : recordDetails){
                    system.debug('--positionEmployeeWrapper ' + positionEmployeeWrapper.record);
                    posEmpList.add(positionEmployeeWrapper.record) ;
                }
                r1 = new Response(draw, posEmpList.size(), posEmpList, false, false, isCallPlanSettingsEnabled);

                /*if(selectedEmployeeId != '')
                    posEmpList = SalesIQUtility.getPositionEmployeeByEmpID(new List<String>{selectedEmployeeId} , new List<String>(), columnHeadersAPIname); 
                else
                    posEmpList = SalesIQUtility.getPositionEmployeeByEmpID(new List<String>() , new List<String>{selectedPositionId} , columnHeadersAPIname);  
                r1 = new Response(draw, posEmpList.size(), posEmpList, false);*/
                system.debug('--posEmpList ' + posEmpList);   
            }

            return r1 ;
        } catch(Exception e) {
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
            throw ex;
        }
    }


    @AuraEnabled
    public static Integer submissionPendingRecords(String selectedTeamInstanceId, String selectedPositionId){
        return SalesIQUtility.submissionPendingRecordsPACP(selectedTeamInstanceId, selectedPositionId).size();
    }

    @AuraEnabled
    public static  Map<String,List<String>> saveCallPlan(String updatedRecs, String selectedTeamInstanceId, String selectedPositionId, String operationType)
    {
        try {
            system.debug('+++++++++++++++++ UpdatedRecsMap --' + updatedRecs + '--');

            Map<String,List<String>> saveReturnMap = new Map<String,List<String>>();

            Map<String, Schema.SObjectType> globalDescribe = Schema.getGlobalDescribe();
            Map<String, Schema.SObjectField> pacpFieldsMap = globalDescribe.get(namespacePrefix+'Position_Account_Call_Plan__c').getDescribe().fields.getMap();

            Map<String,Map<String,String>> changedMade = new Map<String,Map<String,String>>();

            if(updatedRecs != '""')
                changedMade = (Map<String,Map<String,String>>)JSON.deserialize(updatedRecs, Map<String,Map<String,String>>.Class);

            if(changedMade !=null && changedMade.size()>0)
            {   
                Set<String> changedIdSet = changedMade.keySet();
                Set<String> changedFieldsSet = new Set<String>();

                for(String pacpId:changedIdSet)
                    changedFieldsSet.addAll(changedMade.get(pacpId).keySet());

                List<String> changedFieldsList = new List<String>();
                changedFieldsSet.remove('rowIndex');
                System.debug('---> changedFields::' + changedFieldsSet);

                for(String changedField : changedFieldsSet)
                {
                    changedField = changedField.toLowerCase();
                    if(changedField.containsIgnoreCase('_updated__c'))
                    {
                        changedFieldsList.add(changedField);
                        System.debug(changedField.replace('_updated__c', '_approved__c'));
                        changedField = changedField.replace('_updated__c', '_approved__c');
                    }

                    // another clause to add change action type approved field
                    else if(changedField.containsIgnoreCase('Change_Action_Type__c'))
                    {
                        changedFieldsList.add(changedField);
                        changedField = changedField.replace('change_action_type__c', 'change_action_type_approved__c');
                    }

                    // added both updated and approved version of fields
                    changedFieldsList.add(changedField);
                }
                
                System.debug('---> changedFields::' + changedFieldsList);
                
                String queryString = 'Select Id,Change_Status__c,'+ String.join(changedFieldsList,',') +' FROM Position_Account_Call_Plan__c WHERE Id in: changedIdSet'; 
                List<Position_Account_Call_Plan__c> changedRecords = Database.query(queryString);
                List<String> changedRows = new List<String>();
                Map<Id, Position_Account_Call_Plan__c> updatePendingList = new Map<Id, Position_Account_Call_Plan__c>();
                List<String> updateStatusList = new List<String>();
                Map<Id, String> addedTargetUpdateStatus = new Map<Id, String>();

                for(Position_Account_Call_Plan__c pacpRecord : changedRecords)
                {
                    Integer f = 0;
                    Boolean actionDroppedAndUndropped = false;
                    for(String changedApiName : changedMade.get(pacpRecord.Id).keySet())
                    {
                        if(changedApiName != 'rowIndex')
                        {
                            if(pacpRecord.get(changedApiName.toLowerCase().replace('_updated__c', '_approved__c')) == null && String.valueOf(changedMade.get(pacpRecord.Id).get(changedApiName)) == '')
                            {
                                continue;
                            }
                            else if(changedApiName == (namespacePrefix+'Change_Action_Type__c') && (String.valueOf(changedMade.get(pacpRecord.Id).get(changedApiName)) == SalesIQGlobalConstants.CALL_PLAN_EDITED || String.valueOf(changedMade.get(pacpRecord.Id).get(changedApiName)) == '')) {
                                // ignore change in action type field

                                // SPD-4987
                                // Blank or Edited action type will get ignored if originally action action type was added and further iteration will find if any data changes exist and 
                                if(pacpRecord.get('Change_Action_Type__c') == SalesIQGlobalConstants.TARGET_ADDED)
                                    actionDroppedAndUndropped = true;
                                else
                                    continue;
                            }
                            else if(String.valueOf(pacpRecord.get(changedApiName.toLowerCase().replace('_updated__c', '_approved__c'))) != String.valueOf(changedMade.get(pacpRecord.Id).get(changedApiName)))
                            {
                                System.debug('Case2:::' + String.valueOf(pacpRecord.get(changedApiName.toLowerCase().replace('_updated__c', '_approved__c'))) + ':::' + String.valueOf(changedMade.get(pacpRecord.Id).get(changedApiName)) + '::::' + changedApiName + ':::' + changedApiName.toLowerCase().replace('_updated__c', '_approved__c'));
                                f = 1;
                            }
                        }
                    }
                    if(f == 1)
                    {
                        changedRows.add(changedMade.get(pacpRecord.Id).get('rowIndex'));

                        // current row has change in data but row is also an add target case (with malfunctioned change action type due to drop checkbox)
                        if(actionDroppedAndUndropped) {
                            // store the row to keep the change action type to Added always
                            pacpRecord.Change_Action_Type__c = SalesIQGlobalConstants.TARGET_ADDED;
                            addedTargetUpdateStatus.put(pacpRecord.Id, changedMade.get(pacpRecord.Id).get('rowIndex'));
                        }
                    } 
                    else if(actionDroppedAndUndropped && f == 0) 
                    {
                        // add in list to change status to added in the front end
                        addedTargetUpdateStatus.put(pacpRecord.Id, changedMade.get(pacpRecord.Id).get('rowIndex'));
                        //ignore row to take any action
                        changedMade.remove(pacpRecord.Id);
                    }
                    else
                    {
                        if(pacpRecord.Change_Status__c == SalesIQGlobalConstants.REQUEST_STATUS_SUBMISSION_PENDING)
                        {
                            pacpRecord.Change_Status__c = SalesIQGlobalConstants.REQUEST_STATUS_NO_CHANGE;
                            pacpRecord.Change_Action_Type__c = pacpRecord.Change_Action_Type_Approved__c;
                            updatePendingList.put(pacpRecord.Id, pacpRecord);
                            updateStatusList.add(changedMade.get(pacpRecord.Id).get('rowIndex'));
                        }
                        else
                        {
                            changedMade.remove(pacpRecord.Id);
                        }   
                    }
                }

                if(updatePendingList.size() > 0)
                {
                    update updatePendingList.values();
                }

                saveReturnMap.put('changedRows', changedRows);
                saveReturnMap.put('updateStatus', updateStatusList);
                saveReturnMap.put('addedTargetUpdateStatus', addedTargetUpdateStatus.values());

                List<Position_Account_Call_Plan__c> finalPacpUpdateList = new List<Position_Account_Call_Plan__c>();
                if(changedMade.size() > 0)
                {
                    for(String id : changedMade.keySet())
                    {
                        Position_Account_Call_Plan__c callPlan = new Position_Account_Call_Plan__c();
                        callPlan.ID = String.valueof(id);
                        system.debug('+++++++++++++ '+ changedMade.get(id));

                        Map<String,String> attributeValMap = changedMade.get(id);
                        for(String attributeApiName : attributeValMap.keySet()){
                            if(attributeApiName != 'rowIndex'){

                                if(attributeValMap.get(attributeApiName) == '')
                                    callPlan.put(attributeApiName, null);
                                else if(pacpFieldsMap.get(attributeApiName).getDescribe().getType() == Schema.DisplayType.STRING)
                                    callPlan.put(attributeApiName,String.valueOf(attributeValMap.get(attributeApiName))); 
                                else if(pacpFieldsMap.get(attributeApiName).getDescribe().getType() == Schema.DisplayType.INTEGER)
                                    callPlan.put(attributeApiName,Integer.valueOf(attributeValMap.get(attributeApiName)));
                                else if(pacpFieldsMap.get(attributeApiName).getDescribe().getType() == Schema.DisplayType.DOUBLE)
                                    callPlan.put(attributeApiName,Decimal.valueOf(attributeValMap.get(attributeApiName))); 
                                else if(pacpFieldsMap.get(attributeApiName).getDescribe().getType() == Schema.DisplayType.BOOLEAN)
                                    callPlan.put(attributeApiName,Boolean.valueOf(attributeValMap.get(attributeApiName)));  
                                else if(pacpFieldsMap.get(attributeApiName).getDescribe().getType() == Schema.DisplayType.PICKLIST)
                                    callPlan.put(attributeApiName,String.valueOf(attributeValMap.get(attributeApiName)));
                                else
                                    callPlan.put(attributeApiName,String.valueOf(attributeValMap.get(attributeApiName)));   
                            }
                        }
                        if(!updatePendingList.containsKey(callPlan.Id)) {
                            // change the status only when current record is not part of nullified changes map (i.e changes reverted back to approved, no need to send it for submission)
                            callPlan.Change_Status__c = SalesIQGlobalConstants.REQUEST_STATUS_SUBMISSION_PENDING;
                        }

                        //case for dropping the target, explicitly make target updated to false
                        if(callPlan.Change_Action_Type__c == SalesIQGlobalConstants.TARGET_DROPPED) {
                            callPlan.isTarget_Updated__c = false;
                        } 

                        // case where data is changed for an add target row, it should keep the status to added always
                        if(addedTargetUpdateStatus.containsKey(callPlan.Id)) {
                            callPlan.Change_Action_Type__c = SalesIQGlobalConstants.TARGET_ADDED;
                        }
                        
                        finalPacpUpdateList.add(callPlan);
                    }
                    system.debug('++++++++++ PacpRecs' + finalPacpUpdateList);
                    update finalPacpUpdateList;

                } 
            }   

            saveReturnMap.put('errorMetrics',SalesIQUtility.updatePosMetricSummary(selectedTeamInstanceId, selectedPositionId, 'Call_Plan_Change', SalesIQGlobalConstants.REQUEST_STATUS_PENDING, operationType));
            return saveReturnMap;

        } catch(Exception e) {
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
            throw ex;
        }
    }

    @AuraEnabled
    public static List<String> submitCallPlan(String updatedRecs, String selectedTeamInstanceId, String selectedPositionId)
    {
        try {    
        
            List<String> submitReponseList = new List<String>();

            List<String> errorMetrics = saveCallPlan(updatedRecs, selectedTeamInstanceId, selectedPositionId, 'Submit').get('errorMetrics');
            
            if(errorMetrics != null && errorMetrics.size() > 0){
                
                submitReponseList.add('Error');
                
                String errMetricsString = 'Changes cannot be submitted. Following metrics: ';
                for(String errMetricString : errorMetrics){
                    errMetricsString += errMetricString + ',';
                }
                errMetricsString = errMetricsString.removeEnd(',') + ' breach the threshold values.';
                
                submitReponseList.add(errMetricsString);
                return submitReponseList;
            }
            
            Map<String, Schema.SObjectType> globalDescribe = Schema.getGlobalDescribe();
            Map<String, Schema.SObjectField> pacpFieldsMap = globalDescribe.get(namespacePrefix+'Position_Account_Call_Plan__c').getDescribe().fields.getMap();

            List<Position_Account_Call_Plan__c> pacpRecs = [Select Account__c,isTarget_Updated__c,IsTarget_Approved__c,Change_Action_Type__c,Change_Action_Type_Approved__c, Account__r.AccountNumber from Position_Account_Call_Plan__c where Change_Status__c =: SalesIQGlobalConstants.REQUEST_STATUS_SUBMISSION_PENDING AND Team_Instance__c =: selectedTeamInstanceId AND Position__c =: selectedPositionId];

            Integer addedCount=0,droppedCount=0,editedCount=0;

            for(Position_Account_Call_Plan__c posAccObj : pacpRecs)
            {
                if(posAccObj.IsTarget_Approved__c == false && posAccObj.isTarget_Updated__c == true)
                {
                    addedCount = addedCount+1;
                }
                else if((posAccObj.IsTarget_Approved__c == true && posAccObj.isTarget_Updated__c == false) || String.valueOf(posAccObj.Change_Action_Type__c) == SalesIQGlobalConstants.TARGET_DROPPED)
                {
                    droppedCount = droppedCount + 1;
                }
                else
                {
                    editedCount = editedCount + 1;
                }
            }
            if(addedCount == 0 && droppedCount == 0 && editedCount == 0)
            {
                submitReponseList.add(System.Label.CALL_PLAN_NO_CHANGES_MESSAGE);
            }
            else
            {
                submitReponseList.add(String.valueOf(addedCount));
                submitReponseList.add(String.valueOf(droppedCount));
                submitReponseList.add(String.valueOf(editedCount));
            }
            

            return submitReponseList;



        } catch(Exception e) {
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
            throw ex;
        }
    }

    @AuraEnabled
    public static List<String> confirmSubmitCallPlan(String selectedTeamInstanceId, String selectedPositionId, String profileString)
    {
        try
        {   
            map<String,Object> profile = (map<String,Object>)JSON.deserializeUntyped(profileString);

            list<Object> profileMap = new list<Object>();
            profileMap.add('{');
            for(String key : profile.keySet()){
                System.debug('key :'+key);
                System.debug(profile.get(key));
                profileMap.add(key + '=' + profile.get(key) +'');

            }
            profileMap.add('}');
            System.debug('profileMap :: '+profileMap);
            List<String> submitReponseList = new List<String>();
            Map<String, Schema.SObjectField> pacpFieldsMap = Schema.getGlobalDescribe().get(namespacePrefix+'Position_Account_Call_Plan__c').getDescribe().fields.getMap();

            /** CR Tracking Off user story **/
            Team_Instance__c teamInsObj = SalesIQUtility.getTeamInstanceById(selectedTeamInstanceId);
            if(teamInsObj.Scenario__c != null && !teamInsObj.Scenario__r.CR_Tracking__c){
                System.debug('--inside cr tracking off');
                List<String> approvedFields = new List<String>();
                List<String> updatedFields = new List<String>();

                List<List<String>> updatedApprovedFieldList = SalesIQUtility.getApprovedUpdatedPacpFields();
                approvedFields.addAll(updatedApprovedFieldList[0]);
                updatedFields.addAll(updatedApprovedFieldList[1]);    

                String pendingStatus = SalesIQGlobalConstants.REQUEST_STATUS_SUBMISSION_PENDING;

                String soql = 'SELECT Change_Action_Type__c, Change_Action_Type_Approved__c, ' + String.join(updatedFields, ',') + ',' + String.join(approvedFields, ',') + ' FROM Position_Account_Call_Plan__c WHERE Change_Status__c =: pendingStatus AND Team_Instance__c =: selectedTeamInstanceId AND Position__c =: selectedPositionId';
                List<Position_Account_Call_Plan__c> listPACP = Database.query(soql);

                for(Position_Account_Call_Plan__c pacp : listPACP){
                    for(String fieldName : updatedFields){
                        fieldName = fieldName.toLowerCase();
                        String approvedFieldName = fieldName.replace('_updated__c', '_approved__c');
                        //pacp.put( approvedFieldName,pacp.get(fieldName) );
                        system.debug('FieldName and approvedName ---> ' + fieldName + ' == ' + approvedFieldName);
                        system.debug('== ' + pacpFieldsMap);

                        if(pacpFieldsMap.get(fieldName).getDescribe().getType() == Schema.DisplayType.Double && pacp.get(fieldName) != null && pacpFieldsMap.get(approvedFieldName).getDescribe().getType() != Schema.DisplayType.Double)
                        {
                            pacp.put( approvedFieldName,String.valueOf(Double.valueOf(pacp.get(fieldName))));
                        }
                        else if(pacpFieldsMap.get(fieldName).getDescribe().getType() == Schema.DisplayType.PICKLIST && pacp.get(fieldName) != null && pacpFieldsMap.get(approvedFieldName).getDescribe().getType() == Schema.DisplayType.Double) 
                        {
                            pacp.put( approvedFieldName,Double.valueOf(pacp.get(fieldName)));
                        }
                        else
                            pacp.put( approvedFieldName,pacp.get(fieldName) );
                    }
                    pacp.Change_Status__c = SalesIqGlobalConstants.REQUEST_STATUS_APPROVED;
                    pacp.Change_Action_Type_Approved__c = pacp.Change_Action_Type__c;
                }

                if(listPACP.size() > 0){
                    update listPACP;
                    SalesIQUtility.updatePosMetricSummary(selectedPositionId, selectedTeamInstanceId, 'Call_Plan_Change', SalesIQGlobalConstants.REQUEST_STATUS_APPROVED, '');  
                }

                submitReponseList.add('Success');
                submitReponseList.add(System.Label.Changes_Successful);

                return submitReponseList;
            }
            /** CR tracking off user story end **/

            List<Position_Account_Call_Plan__c> pacpRecs = [Select Account__c, Account__r.AccountNumber from Position_Account_Call_Plan__c where Change_Status__c =: SalesIQGlobalConstants.REQUEST_STATUS_SUBMISSION_PENDING AND Team_Instance__c =: selectedTeamInstanceId AND Position__c =: selectedPositionId];

            
            
            if(pacpRecs.size() > 0){
                Change_Request__c changedRec = new Change_Request__c();                                               
                changedRec.Reason__c =  'Call Plan Changes';
                changedRec.recordtypeId = SalesIQUtility.getselctedRecordType(namespacePrefix + 'Change_Request__c', SalesIQGlobalConstants.REQUEST_TYPE_CALL_PLAN );
                changedRec.RecordTypeID__c = SalesIQUtility.getChangeRequestTypebyRequestType('Call_Plan_Change');
                changedRec.Request_Type_Change__c = SalesIQGlobalConstants.REQUEST_TYPE_CALL_PLAN;  
                changedRec.Source_Position__c = selectedPositionId;
                changedRec.Destination_Position__c = selectedPositionId;  
                changedRec.Team_Instance_ID__c = selectedTeamInstanceId;
                changedRec.Status__c = SalesIQGlobalConstants.REQUEST_STATUS_PENDING;

                list<User> approverlist = new list<User>();
                list<string> response = new list<string>();

                changedRec = SalesIQUtility.CreateApprovals(changedRec, approverlist, response, profileMap);
                changedRec = AlignmentUtility.AssignApproval(changedRec, approverlist, integer.valueOf(TotalApproval__c.getValues('Approvals').No_Of_Approval__c));  
                String configStatus = changedRec.Status__c;
                
                if(approverlist != null && approverlist.size () > 0){

                    String movedAccs = '';
                    for(Position_Account_Call_Plan__c posAccObj : pacpRecs){
                        movedAccs += posAccObj.Id + ',';
                        posAccObj.Change_Status__c = SalesIQGlobalConstants.REQUEST_STATUS_SUBMITTED;
                    }
                    system.debug('++++++++++ PacpRecs' + pacpRecs);
                    update pacpRecs;

                    changedRec.Account_SF_Id__c = movedAccs.removeEnd(',');
                    changedRec.Status__c = SalesIQGlobalConstants.REQUEST_STATUS_PENDING;
                    insert changedRec; 
                    SalesIQUtility.SubmitSelfApproval(changedRec.Id,configStatus);
                    
                    String crName = [select name from Change_Request__c where Id =:changedRec.Id].name; 
                    if(configStatus == SalesIQGlobalConstants.REQUEST_STATUS_APPROVED)
                    {
                        submitReponseList.add('Success');
                        submitReponseList.add('Change Request {0} has been created and autoapproved.');
                        submitReponseList.add(crName);
                        submitReponseList.add('#/sObject/' + changedRec.Id + '/view');
                    }
                    else if(configStatus == SalesIQGlobalConstants.REQUEST_STATUS_PENDING)
                    {
                        submitReponseList.add('Success');
                        // submitReponseList.add('{0} has been generated as the Call Plan has been changed for physicians with IDs :- ' + movedAccNumbers);
                        submitReponseList.add('Change Request {0} has been successfully submitted and is pending approval.');
                        submitReponseList.add(crName);
                        submitReponseList.add('#/sObject/' + changedRec.Id + '/view');
                    } 
                } else {
                    submitReponseList.add('Success');
                    submitReponseList.add(System.Label.No_Approval_Found);
                }
            }
            else{
                submitReponseList.add('Success');
                submitReponseList.add('Nothng to Submit');    
            }
            
            return submitReponseList;
        }
        catch(Exception e) 
        {
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
            throw ex;
        }
    }

    @AuraEnabled
    public static void undoCallPlan(String selectedPositionId, String selectedTeamInstanceId)
    {
        try {
            Map<String, Schema.SObjectType> globalDescribe = Schema.getGlobalDescribe();
            Map<String, Schema.SObjectField> pacpFieldsMap = globalDescribe.get(namespacePrefix+'Position_Account_Call_Plan__c').getDescribe().fields.getMap();
            
            List<String> approvedFields = new List<String>();
            for(String fieldName : pacpFieldsMap.keySet()) {
                if(fieldName.containsIgnoreCase('_approved__c'))
                {
                    if(fieldname.split('checkbox').size() > 1 && fieldname.split('checkbox')[0] == namespacePrefix){
                        if(fieldname.split('checkbox')[1].left(1).isNumeric()){
                            String finalString = fieldname.split('checkbox')[1];
                            if(finalString.substring(1, finalString.length() ) == '_approved__c' || finalString.substring(1, finalString.length() ) == '0_approved__c')
                                approvedFields.add(fieldName);
                        } 
                    }
                    else if(fieldname.split('metric').size() > 1 && fieldname.split('metric')[0] == namespacePrefix){
                        if(fieldname.split('metric')[1].left(1).isNumeric()){
                            String finalString = fieldname.split('metric')[1];
                            if(finalString.substring(1, finalString.length() ) == '_approved__c' || finalString.substring(1, finalString.length() ) == '0_approved__c')
                                approvedFields.add(fieldName);
                        }
                    }
                    else if(fieldname.split('segment').size() > 1 && fieldname.split('segment')[0] == namespacePrefix){
                        if(fieldname.split('segment')[1].left(1).isNumeric()){
                            String finalString = fieldname.split('segment')[1];
                            if(finalString.substring(1, finalString.length() ) == '_approved__c' || finalString.substring(1, finalString.length() ) == '0_approved__c')
                                approvedFields.add(fieldName);
                        }
                    }
                    else if(fieldname.split('picklist').size() > 1 && fieldname.split('picklist')[0] == namespacePrefix){
                        if(fieldname.split('picklist')[1].left(1).isNumeric()){
                            String finalString = fieldname.split('picklist')[1];
                            if(finalString.substring(1, finalString.length() ) == '_metric_approved__c' || finalString.substring(1, finalString.length() ) == '_segment_approved__c' || finalString.substring(1, finalString.length() ) == '0_metric_approved__c' || finalString.substring(1, finalString.length() ) == '0_segment_approved__c')
                                approvedFields.add(fieldName);
                        }
                    } 
                    else if(fieldname == namespacePrefix+'Call_Frequency_Approved__c' || fieldname == namespacePrefix+'Recommended_Calls_Approved__c'
                    || fieldname == namespacePrefix+'Reason_Code_Approved__c' || fieldname == namespacePrefix+'IsTarget_Approved__c')
                        approvedFields.add(fieldName);
                }
            }

            String pendingForSubmission = SalesIQGlobalConstants.REQUEST_STATUS_SUBMISSION_PENDING;

            String soql = 'SELECT Change_Action_Type__c, Change_Action_Type_Approved__c, ' + String.join(approvedFields, ',') + ' FROM Position_Account_Call_Plan__c WHERE Change_Status__c =: pendingForSubmission AND Position__c =: selectedPositionId';
            System.debug('soql--->' + soql);
            List<Position_Account_Call_Plan__c> listPACP = Database.query(soql);

            for(Position_Account_Call_Plan__c pacp : listPACP){
                for(String fieldName : approvedFields){
                    fieldName = fieldName.toLowerCase();
                    String updatedFieldName = fieldName.replace('_approved__c', '_updated__c');
                    
                    System.debug('undo-->' + updatedFieldName + '::: '+ fieldname + '::: '+pacp.get(fieldName) + ':::' + pacpFieldsMap.get(fieldname).getDescribe().getType());
                    
                    if(pacpFieldsMap.get(fieldname).getDescribe().getType() == Schema.DisplayType.Double && pacp.get(fieldName) != null && pacpFieldsMap.get(updatedFieldName).getDescribe().getType() != Schema.DisplayType.Double)
                    {
                        pacp.put( updatedFieldName,String.valueOf(Double.valueOf(pacp.get(fieldName))));
                    }
                    else
                        pacp.put( updatedFieldName,pacp.get(fieldName) );
                }

                pacp.Change_Status__c = SalesIQGlobalConstants.REQUEST_STATUS_NO_CHANGE;
                if(pacp.Change_Action_Type_Approved__c != null)
                    pacp.Change_Action_Type__c = pacp.Change_Action_Type_Approved__c;
                else
                    pacp.Change_Action_Type__c = '';            }

            if(listPACP.size() > 0){
                update listPACP;
                SalesIQUtility.updatePosMetricSummary(selectedTeamInstanceId, selectedPositionId, 'Call_Plan_Change', SalesIQGlobalConstants.REQUEST_STATUS_APPROVED, '');
            }
        } catch(Exception e) {
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
            throw ex;
        }
    }

    @AuraEnabled
    public static Position_Account_Call_Plan__c undoRow(String selectedPositionId, String selectedTeamInstanceId,String recordId, String columnHeadersAPIname)
    {
        try 
        {
            /*Map<String, Schema.SObjectType> globalDescribe = Schema.getGlobalDescribe();
            Map<String, Schema.SObjectField> pacpFieldsMap = globalDescribe.get(namespacePrefix+'Position_Account_Call_Plan__c').getDescribe().fields.getMap();
            
            List<String> approvedFields = new List<String>();
            for(String fieldName : pacpFieldsMap.keySet()) 
            {
                if(fieldName.containsIgnoreCase('_approved__c'))
                {
                    if(fieldname.split('checkbox').size() > 1 && fieldname.split('checkbox')[0] == namespacePrefix){
                        if(fieldname.split('checkbox')[1].left(1).isNumeric()){
                            String finalString = fieldname.split('checkbox')[1];
                            if(finalString.substring(1, finalString.length() ) == '_approved__c' || finalString.substring(1, finalString.length() ) == '0_approved__c')
                                approvedFields.add(fieldName);
                        } 
                    }
                    else if(fieldname.split('metric').size() > 1 && fieldname.split('metric')[0] == namespacePrefix){
                        if(fieldname.split('metric')[1].left(1).isNumeric()){
                            String finalString = fieldname.split('metric')[1];
                            if(finalString.substring(1, finalString.length() ) == '_approved__c' || finalString.substring(1, finalString.length() ) == '0_approved__c')
                                approvedFields.add(fieldName);
                        }
                    }
                    else if(fieldname.split('segment').size() > 1 && fieldname.split('segment')[0] == namespacePrefix){
                        if(fieldname.split('segment')[1].left(1).isNumeric()){
                            String finalString = fieldname.split('segment')[1];
                            if(finalString.substring(1, finalString.length() ) == '_approved__c' || finalString.substring(1, finalString.length() ) == '0_approved__c')
                                approvedFields.add(fieldName);
                        }
                    }
                    else if(fieldname.split('picklist').size() > 1 && fieldname.split('picklist')[0] == namespacePrefix){
                        if(fieldname.split('picklist')[1].left(1).isNumeric()){
                            String finalString = fieldname.split('picklist')[1];
                            if(finalString.substring(1, finalString.length() ) == '_metric_approved__c' || finalString.substring(1, finalString.length() ) == '_segment_approved__c' || finalString.substring(1, finalString.length() ) == '0_metric_approved__c' || finalString.substring(1, finalString.length() ) == '0_segment_approved__c')
                                approvedFields.add(fieldName);
                        }
                    } 
                    else if(fieldname == namespacePrefix+'Call_Frequency_Approved__c' || fieldname == namespacePrefix+'Recommended_Calls_Approved__c'
                    || fieldname == namespacePrefix+'Reason_Code_Approved__c' || fieldname == namespacePrefix+'IsTarget_Approved__c')
                        approvedFields.add(fieldName);
                }
            }

            String pendingForSubmission = SalesIQGlobalConstants.REQUEST_STATUS_SUBMISSION_PENDING;
            for(String appfieldName : approvedFields)
            {
                columnHeadersAPIname = columnHeadersAPIname.replaceAll('(?i)'+Pattern.quote(appfieldName),'');
            }
            if(columnHeadersAPIname.startsWith(','))
            {
                columnHeadersAPIname = columnHeadersAPIname.replaceFirst(',','');
            }*/

            List<String> approvedFields = new List<String>();
            List<String> updatedFields = new List<String>();

            List<List<String>> updatedApprovedFieldList = SalesIQUtility.getApprovedUpdatedPacpFields();
            approvedFields.addAll(updatedApprovedFieldList[0]);
            updatedFields.addAll(updatedApprovedFieldList[1]);  

            List<String> fieldList = columnHeadersAPIname.split(',');
            List<String> convertedFieldList = new List<String>();
            for(String field : fieldList){
                convertedFieldList.add(field.toLowerCase());
            }
            Set<String> fieldSet = new Set<String>();
            fieldSet.addAll(approvedFields);
            fieldSet.addAll(updatedFields);
            fieldSet.addAll(convertedFieldList);

            if(!fieldset.contains('AxtriaSalesIQTM__change_action_type__c') && !fieldset.contains('axtriasalesiqtm__change_action_type__c') && !fieldset.contains('AxtriaSalesIQTM__Change_Action_Type__c'))
                fieldSet.add('change_action_type__c');

            if(!fieldset.contains('AxtriaSalesIQTM__change_action_type_approved__c') && !fieldset.contains('axtriasalesiqtm__change_action_type_approved__c') && !fieldset.contains('AxtriaSalesIQTM__Change_Action_Type_Approved__c'))
                fieldSet.add('change_action_type_approved__c');
            
            fieldList.clear();
            fieldList.addAll(fieldSet);

            String soql = 'SELECT ' + String.join(fieldList, ',')  + ' FROM Position_Account_Call_Plan__c WHERE Id =: recordId';
            //String soql = 'SELECT Change_Action_Type_Approved__c, ' + columnHeadersAPIname + ',' + String.join(approvedFields, ',') + ' FROM Position_Account_Call_Plan__c WHERE Id =: recordId';
            System.debug('soql--->' + soql);
            List<Position_Account_Call_Plan__c> listPACP = Database.query(soql);

            Map<String, Schema.SObjectType> globalDescribe = Schema.getGlobalDescribe();
            Map<String, Schema.SObjectField> pacpFieldsMap = globalDescribe.get(namespacePrefix+'Position_Account_Call_Plan__c').getDescribe().fields.getMap();
            for(Position_Account_Call_Plan__c pacp : listPACP){
                for(String fieldName : approvedFields){
                    fieldName = fieldName.toLowerCase();
                    String updatedFieldName = fieldName.replace('_approved__c', '_updated__c');
                    
                    System.debug('undo-->' + updatedFieldName + '::: '+ fieldname + '::: '+pacp.get(fieldName) + ':::' + pacpFieldsMap.get(fieldname).getDescribe().getType());
                    
                    if(pacpFieldsMap.get(fieldname).getDescribe().getType() == Schema.DisplayType.Double && pacp.get(fieldName) != null && pacpFieldsMap.get(updatedFieldName).getDescribe().getType() != Schema.DisplayType.Double)
                    {
                        pacp.put( updatedFieldName,String.valueOf(Double.valueOf(pacp.get(fieldName))));
                    }
                    else
                        pacp.put( updatedFieldName,pacp.get(fieldName) );
                }

                pacp.Change_Status__c = SalesIQGlobalConstants.REQUEST_STATUS_NO_CHANGE;
                if(pacp.Change_Action_Type_Approved__c != null)
                    pacp.Change_Action_Type__c = pacp.Change_Action_Type_Approved__c;
                else
                    pacp.Change_Action_Type__c = '';
            }

            if(listPACP.size() > 0){
                update listPACP;
                SalesIQUtility.updatePosMetricSummary(selectedTeamInstanceId, selectedPositionId, 'Call_Plan_Change', SalesIQGlobalConstants.REQUEST_STATUS_APPROVED, '');
            }

            return listPACP[0];

        } catch(Exception e) {
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
            throw ex;
        }
    }

    @AuraEnabled
    public static void logException(String message,String module) 
    {
        if(message.length() > 2000)
           message = message.substring(0,2000); 
        SalesIQLogger.logErrorMessage(message, module);
    }

    public class ColumnsHeaderResponse
    {
        public String columnHeaderDetailJson;
        public String columnHeaderJson;
        public String sortOrderDefault;
        public String selectedTeamInstanceId;
        public String selectedTeamInstanceStartDate;
        public String selectedTeamInstanceEndDate;
        public String selectedPositionId;
        public String teamInstanceDisplayName;
        public String scenarioStage;
        public String scenarioID;
        public String workspaceID;
        public String scenarioSource;
        public String allFieldsAPI;
        public Boolean bulkEditAllowed;
        public Boolean paginationOn;
        public Decimal paginationSize;
        public Decimal fixedColumnFromLeft;
        public Decimal fixedColumnFromRight;
        public Decimal rowHeight;
        public Boolean isWrapText;
        public Decimal maximumRecordsSaved;

        public ColumnsHeaderResponse(String columnDetails, String columns, String teamInstanceId, String positionId, String teamInstanceName, String stage, String allFields, String orderDefault)
        {
            columnHeaderDetailJson = columnDetails;
            columnHeaderJson = columns;
            selectedTeamInstanceId = teamInstanceId;
            selectedPositionId = positionId;
            teamInstanceDisplayName = teamInstanceName;
            scenarioStage = stage;
            allFieldsAPI = allFields;
            sortOrderDefault = orderDefault;
        }
    }

    public class ColumnHeaderWrapper 
    {
        public String fieldApiName {get; set;}
        public String fieldDisplayName {get;set;}
        public String fieldDefaultSort {get;set;}
        public String fieldDataType {get;set;}
        public Boolean isEnabled {get;set;}
        public Boolean isRequired {get;set;}
        public Boolean isEditable {get;set;}
        public Decimal width {get;set;}
        public String dynamicValuesString {
            get {
                return dynamicValues != null ? String.join(dynamicValues, ',') : '' ;
            } private set;
        }

        // @todo: will rewrite during field dependency
        public List<String> dynamicValues {get;set;}

         public ColumnHeaderWrapper(String dataType)
        {
            if(dataType == 'Id')
            {
                fieldApiName = 'Id';
                fieldDisplayName = 'Id';
                fieldDataType = 'Text';
            }
            else
                fieldDataType = dataType;
        }    

        public ColumnHeaderWrapper(Team_Instance_Object_Attribute__c attribute, List<Team_Instance_Object_Attribute_Detail__c> attributeDetails)
        {
            fieldApiName = attribute.Attribute_API_Name__c;
            fieldDisplayName = attribute.Attribute_Display_Name__c;
            fieldDefaultSort = attribute.Default_Sort__c;
            fieldDataType = attribute.Data_Type__c;
            width = attribute.Width__c;
            isEnabled = attribute.isEnabled__c;
            isRequired = attribute.isRequired__c;
            isEditable = attribute.isEditable__c;
            dynamicValues = new List<String>();
            
            if(attribute.Data_Type__c == Schema.DisplayType.PICKLIST.name()) {

                Map<Integer, String> indexToValMap = new Map<Integer, String>();
                Integer min, max ;
                for(Team_Instance_Object_Attribute_Detail__c attrDetails : attributeDetails) {
                    Integer seqCount = Integer.valueof(attrDetails.Object_Value_Seq__c);
                    indexToValMap.put(seqCount, attrDetails.Object_Value_Name__c);

                    if(min == null && max == null) {
                        min = seqCount;
                        max = seqCount;
                    } else {
                        if(min > seqCount)
                            min = seqCount;
                        if(max < seqCount)
                            max = seqCount;
                    }
                }
                // add sorted value in the list
                for(Integer counter = min; counter <= max; counter++)
                {
                    if(indexToValMap.containsKey(counter))
                        dynamicValues.add(indexToValMap.get(counter));   
                }
            }
        }
    }

    @AuraEnabled
    public static map<String, list<Dependency_Control_Condition__c>> getDependencyControlData(string teamInstanceId)
    {

       list<Dependency_Control_Condition__c> conditions = new list<Dependency_Control_Condition__c>();
       conditions = [select Dependency_Control__c,Dependency_Control__r.Name, Dependency_Control__r.Controlling_Field_1__c,
                    Dependency_Control__r.Controlling_Field_2__c,Dependency_Control__r.Dependent_Field_1__c,Dependency_Control__r.Dependent_Field_2__c,
                    Dependent_Field_1_Values__c, Dependent_Field_2_Values__c,Entry_Criteria_1__c,
                    Entry_Criteria_2__c, Error__c,Mandatory__c, Team_Instance__c from Dependency_Control_Condition__c 
                    where Team_Instance__c =: teamInstanceId AND IsActive__c = true AND Dependency_Control__r.IsActive__c = true];

        System.debug('conditions.size() : '+conditions.size());
        map<String, list<Dependency_Control_Condition__c>> dependencyMap = new map<String, list<Dependency_Control_Condition__c>>();
        for(Dependency_Control_Condition__c dcc : conditions)
        {
            System.debug('dcc: '+dcc);
            if((dcc.Dependency_Control__r.Controlling_Field_1__c != null || dcc.Dependency_Control__r.Controlling_Field_1__c != '') && dcc.Dependency_Control__r.Controlling_Field_2__c == null)
            {
                if(dependencyMap.containsKey(dcc.Dependency_Control__r.Controlling_Field_1__c))
                {
                    list<Dependency_Control_Condition__c> dcctemp = new list<Dependency_Control_Condition__c>();
                    dcctemp.addAll(dependencyMap.get(dcc.Dependency_Control__r.Controlling_Field_1__c));
                    dcctemp.add(dcc);
                    dependencyMap.put(dcc.Dependency_Control__r.Controlling_Field_1__c, dcctemp);
                }
                else
                {
                    dependencyMap.put(dcc.Dependency_Control__r.Controlling_Field_1__c, new list<Dependency_Control_Condition__c>{dcc});
                }
            }
            else 
            {
                if(dependencyMap.containsKey(dcc.Dependency_Control__r.Controlling_Field_1__c +';'+dcc.Dependency_Control__r.Controlling_Field_2__c))
                {
                    list<Dependency_Control_Condition__c> dcctemp = new list<Dependency_Control_Condition__c>();
                    dcctemp.addAll(dependencyMap.get(dcc.Dependency_Control__r.Controlling_Field_1__c +';'+dcc.Dependency_Control__r.Controlling_Field_2__c));
                    dcctemp.add(dcc);
                    dependencyMap.put(dcc.Dependency_Control__r.Controlling_Field_1__c +';'+dcc.Dependency_Control__r.Controlling_Field_2__c, dcctemp);
                }
                else
                {
                    dependencyMap.put(dcc.Dependency_Control__r.Controlling_Field_1__c +';'+dcc.Dependency_Control__r.Controlling_Field_2__c, new list<Dependency_Control_Condition__c>{dcc});
                }
            }
            
        }
        System.debug('dependencyMap : '+dependencyMap);
        return dependencyMap;
    }

    // this method is created to get profilemap for translation in controller.js 
    @AuraEnabled 
    public static map<String,list<String>> getProfileNameMap(){

        map<String,list<String>> profileNameMap = new map<String,list<String>>();
        profileNameMap.put('HO',SalesIQGlobalConstants.HO_PROFILE);
        profileNameMap.put('HR',SalesIQGlobalConstants.HR_PROFILE);
        profileNameMap.put('DM',SalesIQGlobalConstants.DM_PROFILE);
        profileNameMap.put('RM',SalesIQGlobalConstants.RM_PROFILE);
        profileNameMap.put('Rep',SalesIQGlobalConstants.REP_PROFILE);
        //profileNameMap.put('System Administrator',SalesIQGlobalConstants.SalesIQProfile('System Administrator'));

        return profileNameMap;
        
    }


    public class Response 
    {
        @AuraEnabled
        public Integer draw;
        @AuraEnabled
        public Integer recordsTotal;
        @AuraEnabled
        public Integer recordsFiltered;
        @AuraEnabled
        public list<SObject> data;
        @AuraEnabled
        public Boolean isCRraised;
        @AuraEnabled 
        public Boolean isReadOnly;
        @AuraEnabled
        public Boolean isCallPlanSettingsEnabled;

        public Response(Integer draw, Integer size, list<SObject> data, Boolean crRaised, Boolean isReadOnly, Boolean isCallPlanSettingsEnabled)
        {
            this.draw = draw;
            this.recordsTotal = size;
            this.recordsFiltered = size;
            this.data = data;
            isCRraised = crRaised;
            this.isReadOnly = isReadOnly;
            this.isCallPlanSettingsEnabled = isCallPlanSettingsEnabled;
        }
    }
    
}